.\" $Id$
.TH PIXMON 1 "16 March 1993" "Version 0.3"
.ta 0.5i +0.5i +0.5i +0.5i +0.5i +0.5i +0.5i +0.5i +0.5i +0.5i +0.5i +0.5i +0.5i +0.5i +0.5i

\" this noise gets my name right!
.nr 99 \n(.s
.nr 98 \n(.f
.ds 11 "\fRo
.nr 11 \w'\s10\*(11'
.nr 10 0u
.if \n(ct>1 .nr 10 \n(10+\s10.25m\s0
.nr 13 \s10.1m\s0
.if \n(ct>1 .nr 13 \s10.15m\s0
.ds 12 \s10\v'-.67m'..\v'.67m\s0'
.nr 12 \w'\s10\*(12'
.as 11 \h'-\n(11u-\n(12u/2u+\n(13u'\v'0-\n(10u'\*(12\v'\n(10u'\h'-\n(12u+\n(11u/2u-\n(13u'
.ds o \x'0'\f1\s10\*(11\s\n(99\f\n(98

.SH NAME
.B pixmon
\- a simple pixel monitor for X11

.SH SYNOPSIS
.LP
.B pixmon
[
.I -Xt-options ...
]
[
.I -options ...
]
.TP
        [\fB-dx \fI<pixel-data-size>\fR]
.TP
        [\fB-dy \fI<pixel-data-size>\fR]
.TP
        [\fB-width \fI<window-size>\fR]
.TP
        [\fB-height \fI<window-size>\fR]
.TP
        [\fB-scale \fI<float-value>\fR]
.TP
        [\fB-cmap \fI<filename>[.cmap]\fR]
.TP
        [\fB-dither\fR]

.SH DESCRIPTION
.B pixmon
implements a simple 
.I pixel data monitor
for use with the
.I X11
window system. It comes with the following features:
.TP \w'\(bu'u+2n
\(bu
Auto-rescale when changing the window size
.TP
\(bu
Loadable colormaps, you can display the same data with
different colors
.TP
\(bu
Autodetect mono servers, using dithering
.I (ordered dither)
instead of colors
.TP
\(bu
Run length encoding support.

.SH OPTIONS
.TP
.B \-dx \fIpixel-data-size\fR
Set the horizontal size of expected
.I pixel data image.
(Defaults to \fI100\fR.)
.TP
.B \-dy \fIpixel-data-size\fR
Set the vertical size of expected
.I pixel data image.
(Defaults to \fI100\fR.)
.TP
.B \-width \fIwindow-size\fR
Set the horizontal size of
.I pixmon
window in screen coordinates
(Defaults to \fIdx * scale\fR.)
.TP
.B \-height \fIwindow-size\fR
Set the vertical size of
.I pixmon
window in screen coordinates
(Defaults to \fIdy * scale\fR.)
.TP
.B \-scale \fIfloat-value\fR
Scale the window's size to
.I width = dx * float-value
and
.I height = dy * float-value
(Defaults to \fI2\fR.)
.TP
.B \-cmap \fIfilename[.cmap]\fR
Read in \fIfilename[.cmap]\fR on program start, and use the
colors when generating the pixmaps. The use of the
suffix `.cmap' is encouraged, but not enforced.
.TP
.B \-dither
Use an
.I ordered dither
for pseudo color representation on low bitplane devices,
eg.
.I monochrome
X servers.
when used on a color device, a two color dithering generates
some interesting effects.
.PP
The following standard X Toolkit command line arguments are commonly used 
with
.BR pixmon :
.TP
.B \-bg \fIcolor\fP
This option specifies the color to use for the background of the window.  
The default is ``white.''
.TP
.B \-bd \fIcolor\fP
This option specifies the color to use for the border of the window.
The default is ``black.''
.TP
.B \-bw \fInumber\fP
This option specifies the width in pixels of the border surrounding the window.
.TP
.B \-fg \fIcolor\fP
This option specifies the color to use for displaying pixels.  The default is 
``black.''
.TP
.B \-name \fIname\fP
This option specifies the application name under which resources are to be
obtained, rather than the default executable file name.
\fIName\fP should not contain ``.'' or ``*'' characters. (Defaults to
.B ``PixMon.'')
.TP
.B \-title \fIstring\fP
This option specifies the window title string, which may be displayed by
window managers if the user so chooses.  The default title is `pixmon'.
.TP
.B \-rv
This option indicates that reverse video should be simulated by swapping
the foreground and background colors.
.TP
.B \-geometry \fIgeometry\fP
This option specifies the preferred size and position of the
.B pixmon window;
see \fIX(1)\fP.
.TP
.B \-display \fIdisplay\fP
This option specifies the X server to contact; see \fIX(1)\fP.
.TP
.B \-xrm \fIresourcestring\fP
This option specifies a resource string to be used.  This is especially
useful for setting resources that do not have separate command line options.
.TP
.B \-iconic
This option indicates that
.B pixmon
should ask the window manager to 
start it as an icon rather than as the normal window.

.SH OPTION SUMMARY
To give no option at all is the same as to give the following options:
.TP
-dx 100 -dy 100 -scale 2 -cmap default.cmap

.SH FORMATS
.TP \w'\(bu'u+2n
\(bu
.I Color map file(s), recognised by
.B pixmon
have the following
.SM ASCII
layout:
.LP
.nf
.DT
.ft B
	# 	File:		demo.map
	#	Creator:	Joachim Sprave (sprave@gonzo)
	# <- this is a comment line: '#' in the 1st column
	<red intensity 0>	<green intensity 0>	<blue intensity 0>
	<red intensity 1>	<green intensity 1>	<blue intensity 1>
	<red intensity 2>	<green intensity 2>	<blue intensity 2>
				\&.\&.\&.
	<red intensity 255>	<green intensity 255>	<blue intensity 255>
.ft R
.fi

Thus a color map file consist of 256 lines each one containing such a
color description. Eg. to get a greyscale `color' map, simply
use the same intensities for all colors (see
.SM EXAMPLES
below).
.TP \w'\(bu'u+2n
\(bu
A package header is defined as:
.LP
.nf
.DT
.ft B
	typedef struct {
		unsigned short	magic;
		unsigned short	type;
		short		x;
		short		y;
		unsigned short	dx;
		unsigned short	dy;
		unsigned short	sizelo;
		unsigned short	sizehi;
	} ImgHdr;
.ft R
.fi

With the following semantics:
.TP
.I magic
used to determine byte sex, must
be initialized to PIX_MAGIC
.TP
.I type
one of:
.RS
.TP
.SM PIX_DATA
Include the pixel data following 
the header into the picture 
(without displaying instantly).
.TP
.SM PIX_FLUSH
Display the internal pixmap.
.TP
.SM PIX_DATA | PIX_FLUSH
Include the pixel data following 
the header into the picture 
and display it instantly.
.TP
.SM PIX_KILL
Tells
.B pixmon
to exit, when button 1 is pressed.
.RE
.TP
.I x, y
Position of this package relative to
the upper-left corner of the window.
.TP
.I dx, dy
Width and height (in dots, not in pixels)
of this package.
.TP
.I sizelo, sizehi			
Size of the following pixel data. If
.I sizehi * 0x10000 + sizelo
.I < dx * dy,
.B pixmon
expects run length encoded data.

.SH ENCODING
If
.SM RUN LENGTH ENCODING (RLE)
is detected (see above), the value
.BR PIX_RLE (0xFF)
is treated as an escape value,
so the number of colors is reduced by one.
To encode your data, use the function
.B rle_encode
from
.I rle.c.

.SH EXAMPLES
.TP \w'\(bu'u+2n
\(bu
A
.I greyscale
color map looks like:
.LP
.nf
.DT
.ft R
	0	0	0
	1	1	1
	2	2	2
	3	3	3
		\&.\&.\&.
	255	255	255
.fi
.TP \w'\(bu'u+2n
\(bu
To use run length encoding of your pixel data, write:
.LP
.nf
.DT
.ft B
	my_encode ()
	{
		char mybuffer[MBSIZE];
		\&.\&.\&.
		rle_encode (mybuffer, MBSIZE, PIX_RLE);
		\&.\&.\&.
	}
.ft R
.fi

.SH FILES
.LP
.nf
.DT
.ft R
pixmon/default.cmap		\fIdefault color map\fR
pixmon/cmaps/*.cmap		\fIexample color maps\fR

pixmon/examples/README	\fIguiding instructions\fR
pixmon/examples/mbx		\fIshell script that runs mbs\fR
pixmon/examples/mbs.c		\fIgenerates a mandelbrot set\fR
pixmon/examples/showpal.c	\fIgenerates a color palette\fR
.ft R
.fi

.SH ANIMATION
An animation companion to
.B pixmon
called
.BR playmate (1)
is also in the making, and will be distributed in near future
(refer to the
.SM AVAILABILITY
section below).
Its application is rather simple: all there is to do is to
include a ``tee-log'' in the `pixel generating pipe' eg.:
.PP
.RS
.I example%
.B mbs ... | tee >pmdata.pix
.B | pixmon ...
.RE
.PP
to collect
.B pixmon
data, that is later turned into animated pixmaps by
.BR playmate (1).
(See the
.B pixmon/examples
folder for more.)

.SH BUGS
The known `bugs' of
.B pixmon
are:
.TP \w'\(bu'u+2n
\(bu
`No' interaction
.TP
\(bu
Could be faster
.TP
\(bu
No private color maps
.TP
\(bu
My first
.I X11
program, ugly code :-(

.SH SEE ALSO
.BR X (1),
.BR hodge (1),
.BR imagemagick (1),
.BR playmate (1)

.SH AUTHOR
Copyright 
.if t \(co 
.if n (C)
1992, 1993 by
.if n Joachim Sprave
.if t Joachim Sprave
.nf
Systems Analysis Group, University of Dortmund, Germany.
.nf
Send bugs, comments, etc., to (sprave@ls11.informatik.uni-dortmund.de).
.fi

.SH CREDITS
.if n Joerg Heitkoetter
.if t J\*org Heitk\*otter
(joke@ls11.informatik.uni-dortmund.de) wrote the manual page.
.fi

.SH AVAILABILITY
.LP
This work is protected by the terms of the
.SM GNU
General Public License. Please refer to the
.SM COPYING
file accompanying the sources of this software package for a lengthy, boring,
but absolute complete description.

.SM PIXMON
is available via anonymous ftp from the group's server
.B lumpi.informatik.uni-dortmunde.de
(129.217.36.140)
as file `pixmon-0.3.tar.Z' in /pub/CA/src.

.SH WARRANTY
.LP
This program is free software; you can redistribute it and/or modify
it under the terms of the
.SM GNU
General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but
.SM WITHOUT ANY WARRANTY;
without even the implied warranty of
.SM MERCHANTABILITY
or
.SM FITNESS FOR A PARTICULAR PURPOSE.
See the
.SM GNU
General Public License for more details.

You should have received a copy of the
.SM GNU
General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
